Package: org.codehaus.groovy.tools

## [Java] Class FileSystemCompiler

- org.codehaus.groovy.tools.FileSystemCompiler

- Command-line compiler (aka. `groovyc`).

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `FileSystemCompiler.CompilationOptions` | @since 2.5

  - ### Constructor Summary

    Constructors
    Constructor and description
    `FileSystemCompiler (CompilerConfiguration configuration)`
    `FileSystemCompiler (CompilerConfiguration configuration, org.codehaus.groovy.control.CompilationUnit cu)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `static int` | `checkFiles(String[] filenames)`
    `` | `static void` | `commandLineCompile(String[] args)` Same as main(args) except that exceptions are thrown out instead of causing the VM to exit.
    `` | `static void` | `commandLineCompile(String[] args, boolean lookupUnnamedFiles)` Same as main(args) except that exceptions are thrown out instead of causing the VM to exit and the lookup for .groovy files can be controlled
    `` | `static void` | `commandLineCompileWithErrorHandling(String[] args, boolean lookupUnnamedFiles)` Primary entry point for compiling from the command line (using the groovyc script).
    `` | `void` | `compile(String[] paths)`
    `` | `void` | `compile(File[] files)`
    `` | `static CommandLine` | `configureParser(FileSystemCompiler.CompilationOptions options)`
    `` | `static Options` | `createCompilationOptions()`
    `` | `static File` | `createTempDir()` Creates a temporary directory in the default temporary directory (as specified by the system property java.io.tmpdir.
    `` | `static void` | `deleteRecursive(File file)`
    `` | `static void` | `displayHelp()` Prints the usage help message for CompilationOptions to stderr.
    `` | `static void` | `displayHelp(PrintWriter writer)` Prints the usage help message for the CompilationOptions to the specified PrintWriter.
    `` | `static void` | `displayHelp(Options options)` @deprecated use displayHelp(PrintWriter) instead
    `` | `static void` | `displayVersion()` Prints version information to stderr.
    `` | `static void` | `displayVersion(PrintWriter writer)` Prints version information to the specified PrintWriter.
    `` | `static void` | `doCompilation(CompilerConfiguration configuration, org.codehaus.groovy.control.CompilationUnit unit, String[] filenames)`
    `` | `static void` | `doCompilation(CompilerConfiguration configuration, org.codehaus.groovy.control.CompilationUnit unit, String[] filenames, boolean lookupUnnamedFiles)`
    `` | `static CompilerConfiguration` | `generateCompilerConfigurationFromOptions(CommandLine cli)`
    `` | `static String[]` | `generateFileNamesFromOptions(CommandLine cli)`
    `` | `static void` | `main(String[] args)` Primary entry point for compiling from the command line (using the groovyc script).
    `` | `static boolean` | `validateFiles(String[] filenames)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Constructor Detail

    - #### public FileSystemCompiler(CompilerConfiguration configuration)

    - #### public FileSystemCompiler(CompilerConfiguration configuration, org.codehaus.groovy.control.CompilationUnit cu)

  - ### Method Detail

    - #### public static int checkFiles(String[] filenames)

    - #### public static void commandLineCompile(String[] args)

      Same as main(args) except that exceptions are thrown out instead of causing the VM to exit.

    - #### public static void commandLineCompile(String[] args, boolean lookupUnnamedFiles)

      Same as main(args) except that exceptions are thrown out instead of causing the VM to exit and the lookup for .groovy files can be controlled

    - #### public static void commandLineCompileWithErrorHandling(String[] args, boolean lookupUnnamedFiles)

      Primary entry point for compiling from the command line (using the groovyc script).

      If calling inside a process and you don't want the JVM to exit on an error call commandLineCompile(String[]), which this method simply wraps

      Parameters:
        `args` - command line arguments
        `lookupUnnamedFiles` - do a lookup for .groovy files not part of the given list of files to compile

    - #### public void compile(String[] paths)

    - #### public void compile(File[] files)

    - #### public static CommandLine configureParser(FileSystemCompiler.CompilationOptions options)

    - #### @Deprecated public static Options createCompilationOptions()

    - #### @Deprecated public static File createTempDir()

      Creates a temporary directory in the default temporary directory (as specified by the system property java.io.tmpdir.

      deprecated:
        Use DefaultGroovyStaticMethods#createTempDir(java.io.File, String, String) instead.

    - #### public static void deleteRecursive(File file)

    - #### public static void displayHelp()

      Prints the usage help message for CompilationOptions to stderr.

      See Also:
        displayHelp(PrintWriter)
      Since:
        2.5

    - #### public static void displayHelp(PrintWriter writer)

      Prints the usage help message for the CompilationOptions to the specified PrintWriter.

      Since:
        2.5

    - #### @Deprecated public static void displayHelp(Options options)

      deprecated:
        use displayHelp(PrintWriter) instead

    - #### public static void displayVersion()

      Prints version information to stderr.

      See Also:
        displayVersion(PrintWriter)

    - #### public static void displayVersion(PrintWriter writer)

      Prints version information to the specified PrintWriter.

      Since:
        2.5

    - #### public static void doCompilation(CompilerConfiguration configuration, org.codehaus.groovy.control.CompilationUnit unit, String[] filenames)

    - #### public static void doCompilation(CompilerConfiguration configuration, org.codehaus.groovy.control.CompilationUnit unit, String[] filenames, boolean lookupUnnamedFiles)

    - #### @Deprecated public static CompilerConfiguration generateCompilerConfigurationFromOptions(CommandLine cli)

    - #### @Deprecated public static String[] generateFileNamesFromOptions(CommandLine cli)

    - #### public static void main(String[] args)

      Primary entry point for compiling from the command line (using the groovyc script).

      If calling inside a process and you don't want the JVM to exit on an error call commandLineCompile(String[]), which this method simply wraps

      Parameters:
        `args` - command line arguments

    - #### public static boolean validateFiles(String[] filenames)